-- MySQL dump 10.9
--
-- Host: localhost    Database: szakdoga
-- ------------------------------------------------------
-- Server version	4.1.11-Debian_3-log

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `buildings`
--

DROP TABLE IF EXISTS `buildings`;
CREATE TABLE `buildings` (
  `bid` int(11) NOT NULL auto_increment,
  `bname` char(64) NOT NULL default '',
  `bsname` char(8) NOT NULL default '',
  PRIMARY KEY  (`bid`),
  UNIQUE KEY `bsname` (`bsname`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Table structure for table `posts`
--

DROP TABLE IF EXISTS `posts`;
CREATE TABLE `posts` (
  `postid` int(11) NOT NULL auto_increment,
  `uid` int(11) NOT NULL default '0',
  `tid` int(11) NOT NULL default '0',
  `dt` datetime NOT NULL default '0000-00-00 00:00:00',
  `t` text NOT NULL,
  PRIMARY KEY  (`postid`),
  KEY `topic_ind` (`tid`),
  KEY `post_uid_idn` (`uid`),
  CONSTRAINT `posts_ibfk_1` FOREIGN KEY (`tid`) REFERENCES `topics` (`tid`) ON DELETE CASCADE,
  CONSTRAINT `posts_ibfk_2` FOREIGN KEY (`uid`) REFERENCES `users` (`sid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Table structure for table `room_conn_student`
--

DROP TABLE IF EXISTS `room_conn_student`;
CREATE TABLE `room_conn_student` (
  `roomid` int(11) NOT NULL default '0',
  `sid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`roomid`,`sid`),
  KEY `sid` (`sid`),
  CONSTRAINT `room_conn_student_ibfk_1` FOREIGN KEY (`roomid`) REFERENCES `rooms` (`roomid`) ON DELETE CASCADE,
  CONSTRAINT `room_conn_student_ibfk_2` FOREIGN KEY (`sid`) REFERENCES `users` (`sid`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Table structure for table `rooms`
--

DROP TABLE IF EXISTS `rooms`;
CREATE TABLE `rooms` (
  `rnum` char(10) NOT NULL default '',
  `rname` char(52) default NULL,
  `roomid` int(11) NOT NULL auto_increment,
  `space` int(11) NOT NULL default '0',
  `bid` int(11) NOT NULL default '0',
  `rtype` enum('ST_HOMOGEN','ST_MALE','ST_FEMALE','ST_HETEROGEN') NOT NULL default 'ST_HOMOGEN',
  PRIMARY KEY  (`roomid`),
  KEY `rooms_bid_ind` (`bid`),
  CONSTRAINT `rooms_ibfk_bid` FOREIGN KEY (`bid`) REFERENCES `buildings` (`bid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Table structure for table `topics`
--

DROP TABLE IF EXISTS `topics`;
CREATE TABLE `topics` (
  `title` char(255) NOT NULL default '',
  `cuid` int(11) NOT NULL default '0',
  `ct` datetime NOT NULL default '0000-00-00 00:00:00',
  `tid` int(11) NOT NULL auto_increment,
  PRIMARY KEY  (`tid`),
  KEY `cuid_ind` (`cuid`),
  CONSTRAINT `topics_ibfk_1` FOREIGN KEY (`cuid`) REFERENCES `users` (`sid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS `users`;
CREATE TABLE `users` (
  `realname` char(40) NOT NULL default '',
  `username` char(16) NOT NULL default '',
  `password` char(32) NOT NULL default '',
  `sid` int(11) NOT NULL auto_increment,
  `ut` enum('UT_ASTUDENT','UT_OSTUDENT') NOT NULL default 'UT_ASTUDENT',
  `email` char(255) default NULL,
  `sex` enum('M','F') NOT NULL default 'M',
  `bid` int(11) NOT NULL default '0',
  `disabled` enum('Y','N') NOT NULL default 'Y',
  `av` double default NULL,
  PRIMARY KEY  (`sid`),
  UNIQUE KEY `username` (`username`),
  KEY `users_bid_ind` (`bid`),
  CONSTRAINT `users_ibfk_bid` FOREIGN KEY (`bid`) REFERENCES `buildings` (`bid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Table structure for table `variables`
--

DROP TABLE IF EXISTS `variables`;
CREATE TABLE `variables` (
  `name` varchar(48) NOT NULL default '',
  `value` varchar(255) NOT NULL default '',
  `tname` varchar(128) NOT NULL default '',
  `description` text NOT NULL,
  PRIMARY KEY  (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Table structure for table `wishes`
--

DROP TABLE IF EXISTS `wishes`;
CREATE TABLE `wishes` (
  `sid` int(11) NOT NULL default '0',
  `wsid` int(11) NOT NULL default '0',
  `pref` int(11) default NULL,
  `used` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`sid`,`wsid`),
  KEY `wsid` (`wsid`),
  CONSTRAINT `wishes_ibfk_1` FOREIGN KEY (`sid`) REFERENCES `users` (`sid`) ON DELETE CASCADE,
  CONSTRAINT `wishes_ibfk_2` FOREIGN KEY (`wsid`) REFERENCES `users` (`sid`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- MySQL dump 10.9
--
-- Host: localhost    Database: szakdoga
-- ------------------------------------------------------
-- Server version	4.1.11-Debian_3-log

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Dumping data for table `variables`
--


/*!40000 ALTER TABLE `variables` DISABLE KEYS */;
LOCK TABLES `variables` WRITE;
INSERT INTO `variables` (`name`, `value`, `tname`, `description`) VALUES ('edit_wishes_allowed','yes','Kivansaglista szerkesztesenek engedelyezese','igen: a felhasznalok szerkeszthetik a kivansaglistat, nem: nem szerkeszthetik');
INSERT INTO `variables` (`name`, `value`, `tname`, `description`) VALUES ('login_allowed','yes','Bejelentkezesek enegdelyezese','igen, ha engedelyezett a felhasznalok belepese, nem, ha nem');
UNLOCK TABLES;
/*!40000 ALTER TABLE `variables` ENABLE KEYS */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

